Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ExecuterBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ExecuterBase.cs	(revision 2056)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ExecuterBase.cs	(revision 2057)
@@ -69,12 +69,24 @@
     protected abstract void StartJobs();
 
+    protected void SetResults(IScope src, IScope target) {
+      foreach (IVariable v in src.Variables) {
+        target.AddVariable(v);
+      }
+      foreach (IScope subScope in src.SubScopes) {
+        target.AddSubScope(subScope);
+      }
+      foreach (KeyValuePair<string, string> alias in src.Aliases) {
+        target.AddAlias(alias.Key, alias.Value);
+      }
+    }
+
     protected void StoreResults(IAlgorithm finishedAlgorithm) {
       Entity modelEntity = new Entity(Ontology.CedmaNameSpace + Guid.NewGuid());
+      IModel model = finishedAlgorithm.Model;
       List<Statement> statements = new List<Statement>();
       statements.Add(new Statement(modelEntity, Ontology.InstanceOf, Ontology.TypeModel));
-      statements.Add(new Statement(modelEntity, Ontology.TargetVariable, new Literal(finishedAlgorithm.Model.TargetVariable)));
+      statements.Add(new Statement(modelEntity, Ontology.TargetVariable, new Literal(model.TargetVariable)));
       statements.Add(new Statement(modelEntity, Ontology.Name, new Literal(finishedAlgorithm.Description)));
       
-      IModel model = finishedAlgorithm.Model;
       statements.Add(new Statement(modelEntity, Ontology.TrainingMeanSquaredError, new Literal(model.TrainingMeanSquaredError)));
       statements.Add(new Statement(modelEntity, Ontology.ValidationMeanSquaredError, new Literal(model.ValidationMeanSquaredError)));
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/GridExecuter.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/GridExecuter.cs	(revision 2056)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/GridExecuter.cs	(revision 2057)
@@ -107,16 +107,4 @@
     }
 
-    private void SetResults(IScope src, IScope target) {
-      foreach (IVariable v in src.Variables) {
-        target.AddVariable(v);
-      }
-      foreach (IScope subScope in src.SubScopes) {
-        target.AddSubScope(subScope);
-      }
-      foreach (KeyValuePair<string, string> alias in src.Aliases) {
-        target.AddAlias(alias.Key, alias.Value);
-      }
-    }
-
     public override string[] GetJobs() {
       lock (activeAlgorithms) {
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLab.CEDMA.Server-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLab.CEDMA.Server-3.3.csproj	(revision 2056)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLab.CEDMA.Server-3.3.csproj	(revision 2057)
@@ -156,4 +156,8 @@
       <Name>HeuristicLab.PluginInfrastructure</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Tracing\3.2\HeuristicLab.Tracing-3.2.csproj">
+      <Project>{EE2034D9-6E27-48A1-B855-42D45F69A4FC}</Project>
+      <Name>HeuristicLab.Tracing-3.2</Name>
+    </ProjectReference>
   </ItemGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs	(revision 2056)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs	(revision 2057)
@@ -35,4 +35,5 @@
   [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
   [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Tracing-3.2")]
   public class HeuristicLabCedmaServerPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HiveExecuter.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HiveExecuter.cs	(revision 2056)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HiveExecuter.cs	(revision 2057)
@@ -95,4 +95,5 @@
               activeAlgorithms.Remove(readyHandle);
             }
+            SetResults(finishedEngine.GlobalScope, finishedAlgorithm.Engine.GlobalScope);
             StoreResults(finishedAlgorithm);
             readyHandle.Close();
@@ -100,5 +101,5 @@
         }
         catch (Exception ex) {
-          Trace.WriteLine("CEDMA Executer: Exception in job-management thread. " + ex.Message);
+          HeuristicLab.Tracing.HiveLogger.Debug("CEDMA Executer: Exception in job-management thread. " + ex.Message + "\n" + ex.StackTrace);
         }
       }
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/AlgorithmBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/AlgorithmBase.cs	(revision 2056)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/AlgorithmBase.cs	(revision 2057)
@@ -416,4 +416,5 @@
 
     protected internal virtual Model CreateGPModel(IScope bestModelScope) {
+      Engine.GlobalScope.AddSubScope(bestModelScope);
       Model model = new Model();
       Dataset ds = bestModelScope.GetVariableValue<Dataset>("Dataset", true);
@@ -442,4 +443,5 @@
         model.SetVariableQualityImpact(variableName, impact);
       }
+      Engine.GlobalScope.RemoveSubScope(bestModelScope);
       return model;
     }