Index: trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.Designer.cs	(revision 2023)
+++ trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.Designer.cs	(revision 2062)
@@ -46,5 +46,5 @@
     private void InitializeComponent() {
         this.components = new System.ComponentModel.Container();
-        Calendar.DrawTool drawTool2 = new Calendar.DrawTool();
+        Calendar.DrawTool drawTool6 = new Calendar.DrawTool();
         System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HiveClientConsole));
         this.dvOnline = new Calendar.DayView();
@@ -82,7 +82,7 @@
         this.txtLog = new System.Windows.Forms.TextBox();
         this.tabPage2 = new System.Windows.Forms.TabPage();
+        this.btnSaveCal = new System.Windows.Forms.Button();
         this.pictureBox1 = new System.Windows.Forms.PictureBox();
         this.groupBox1 = new System.Windows.Forms.GroupBox();
-        this.btnSaveCal = new System.Windows.Forms.Button();
         this.txttimeTo = new System.Windows.Forms.DateTimePicker();
         this.txttimeFrom = new System.Windows.Forms.DateTimePicker();
@@ -112,6 +112,6 @@
         // dvOnline
         // 
-        drawTool2.DayView = this.dvOnline;
-        this.dvOnline.ActiveTool = drawTool2;
+        drawTool6.DayView = this.dvOnline;
+        this.dvOnline.ActiveTool = drawTool6;
         this.dvOnline.AmPmDisplay = false;
         this.dvOnline.AppointmentDuration = Calendar.AppointmentSlotDuration.SixtyMinutes;
@@ -137,5 +137,4 @@
         // tcClientConsole
         // 
-        this.tcClientConsole.Appearance = System.Windows.Forms.TabAppearance.FlatButtons;
         this.tcClientConsole.Controls.Add(this.tpConnection);
         this.tcClientConsole.Controls.Add(this.tabPage2);
@@ -257,7 +256,7 @@
         // 
         this.gbJobCommon.Controls.Add(this.lvJobDetail);
-        this.gbJobCommon.Location = new System.Drawing.Point(8, 152);
+        this.gbJobCommon.Location = new System.Drawing.Point(8, 139);
         this.gbJobCommon.Name = "gbJobCommon";
-        this.gbJobCommon.Size = new System.Drawing.Size(412, 252);
+        this.gbJobCommon.Size = new System.Drawing.Size(269, 265);
         this.gbJobCommon.TabIndex = 13;
         this.gbJobCommon.TabStop = false;
@@ -270,9 +269,10 @@
             this.chSince,
             this.chProgress});
+        this.lvJobDetail.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lvJobDetail.FullRowSelect = true;
         this.lvJobDetail.GridLines = true;
-        this.lvJobDetail.Location = new System.Drawing.Point(6, 14);
+        this.lvJobDetail.Location = new System.Drawing.Point(3, 16);
         this.lvJobDetail.Name = "lvJobDetail";
-        this.lvJobDetail.Size = new System.Drawing.Size(398, 232);
+        this.lvJobDetail.Size = new System.Drawing.Size(263, 246);
         this.lvJobDetail.TabIndex = 0;
         this.lvJobDetail.UseCompatibleStateImageBehavior = false;
@@ -291,5 +291,4 @@
         // 
         this.chProgress.Text = "Progress";
-        this.chProgress.Width = 200;
         // 
         // gbCommon
@@ -435,7 +434,7 @@
         // 
         this.gbEventLog.Controls.Add(this.txtLog);
-        this.gbEventLog.Location = new System.Drawing.Point(426, 152);
+        this.gbEventLog.Location = new System.Drawing.Point(283, 139);
         this.gbEventLog.Name = "gbEventLog";
-        this.gbEventLog.Size = new System.Drawing.Size(412, 252);
+        this.gbEventLog.Size = new System.Drawing.Size(555, 265);
         this.gbEventLog.TabIndex = 7;
         this.gbEventLog.TabStop = false;
@@ -444,10 +443,10 @@
         // txtLog
         // 
-        this.txtLog.Location = new System.Drawing.Point(4, 14);
+        this.txtLog.Location = new System.Drawing.Point(6, 14);
         this.txtLog.Multiline = true;
         this.txtLog.Name = "txtLog";
         this.txtLog.ReadOnly = true;
         this.txtLog.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
-        this.txtLog.Size = new System.Drawing.Size(402, 232);
+        this.txtLog.Size = new System.Drawing.Size(543, 248);
         this.txtLog.TabIndex = 0;
         // 
@@ -466,4 +465,14 @@
         this.tabPage2.Text = "Schedule";
         this.tabPage2.UseVisualStyleBackColor = true;
+        // 
+        // btnSaveCal
+        // 
+        this.btnSaveCal.Location = new System.Drawing.Point(633, 138);
+        this.btnSaveCal.Name = "btnSaveCal";
+        this.btnSaveCal.Size = new System.Drawing.Size(199, 23);
+        this.btnSaveCal.TabIndex = 41;
+        this.btnSaveCal.Text = "Save calender";
+        this.btnSaveCal.UseVisualStyleBackColor = true;
+        this.btnSaveCal.Click += new System.EventHandler(this.btnSaveCal_Click);
         // 
         // pictureBox1
@@ -495,14 +504,4 @@
         this.groupBox1.TabStop = false;
         // 
-        // btnSaveCal
-        // 
-        this.btnSaveCal.Location = new System.Drawing.Point(633, 138);
-        this.btnSaveCal.Name = "btnSaveCal";
-        this.btnSaveCal.Size = new System.Drawing.Size(199, 23);
-        this.btnSaveCal.TabIndex = 41;
-        this.btnSaveCal.Text = "Save calender";
-        this.btnSaveCal.UseVisualStyleBackColor = true;
-        this.btnSaveCal.Click += new System.EventHandler(this.btnSaveCal_Click);
-        // 
         // txttimeTo
         // 
@@ -627,5 +626,4 @@
         this.Name = "HiveClientConsole";
         this.Text = "Client Console (loading...)";
-        this.Load += new System.EventHandler(this.HiveClientConsole_Load);
         this.tcClientConsole.ResumeLayout(false);
         this.tpConnection.ResumeLayout(false);