Index: trunk/sources/HeuristicLab.Hive.Client.Console/3.2/Properties/Resources.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Console/3.2/Properties/Resources.Designer.cs	(revision 1530)
+++ trunk/sources/HeuristicLab.Hive.Client.Console/3.2/Properties/Resources.Designer.cs	(revision 2069)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:2.0.50727.3053
+//     Runtime Version:2.0.50727.3082
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -61,14 +61,21 @@
         }
         
-        internal static System.Drawing.Bitmap Error {
+        internal static System.Drawing.Bitmap Disaster_warning_48 {
             get {
-                object obj = ResourceManager.GetObject("Error", resourceCulture);
+                object obj = ResourceManager.GetObject("Disaster_warning_48", resourceCulture);
                 return ((System.Drawing.Bitmap)(obj));
             }
         }
         
-        internal static System.Drawing.Bitmap Info {
+        internal static System.Drawing.Bitmap exit_48 {
             get {
-                object obj = ResourceManager.GetObject("Info", resourceCulture);
+                object obj = ResourceManager.GetObject("exit_48", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        internal static System.Drawing.Bitmap Global_network_48 {
+            get {
+                object obj = ResourceManager.GetObject("Global_network_48", resourceCulture);
                 return ((System.Drawing.Bitmap)(obj));
             }
@@ -81,11 +88,4 @@
             }
         }
-        
-        internal static System.Drawing.Bitmap shutdown_icon {
-            get {
-                object obj = ResourceManager.GetObject("shutdown_icon", resourceCulture);
-                return ((System.Drawing.Bitmap)(obj));
-            }
-        }
     }
 }
Index: trunk/sources/HeuristicLab.Hive.Client.Console/3.2/Properties/Resources.resx
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Console/3.2/Properties/Resources.resx	(revision 1530)
+++ trunk/sources/HeuristicLab.Hive.Client.Console/3.2/Properties/Resources.resx	(revision 2069)
@@ -119,15 +119,15 @@
   </resheader>
   <assembly alias="System.Windows.Forms" name="System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
-  <data name="Error" type="System.Resources.ResXFileRef, System.Windows.Forms">
-    <value>..\Resources\Error.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  <data name="Disaster_warning_48" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\Disaster-warning-48.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
-  <data name="Info" type="System.Resources.ResXFileRef, System.Windows.Forms">
-    <value>..\Resources\Info.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  <data name="exit_48" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\exit-48.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="Global_network_48" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\Global-network-48.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
   <data name="schedule" type="System.Resources.ResXFileRef, System.Windows.Forms">
     <value>..\Resources\schedule.jpg;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
-  <data name="shutdown_icon" type="System.Resources.ResXFileRef, System.Windows.Forms">
-    <value>..\Resources\shutdown-icon.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
-  </data>
 </root>