Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissions.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissions.cs	(revision 2069)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/HivePermissions.cs	(revision 2070)
@@ -6,10 +6,13 @@
 using HeuristicLab.Security.Contracts.BusinessObjects;
 using System.Diagnostics;
+using System.Xml;
+using System.IO;
+using System.Reflection;
 
 namespace HeuristicLab.Hive.Server.Core  {
   
   public static class HivePermissions {
-    private const string PERMISSIONFILE = "Authorization//HivePermissionSet.xml";
-    private const string POLICIESFILE = "Authorization//HivePermissionPolicy.xml";
+    private const string PERMISSIONFILE = @"plugins\HivePermissionSet.xml";
+    private const string POLICIESFILE = @"plugins\HivePermissionPolicy.xml";
 
     public static class Jobmanagement {
@@ -144,4 +147,5 @@
       Permission p = null;
       XPathDocument doc;
+      string assemblyName = Assembly.GetAssembly(typeof(HivePermissions)).GetName().Name;
       doc = new XPathDocument(filename);
       XPathNavigator nav = doc.CreateNavigator();
@@ -164,5 +168,35 @@
       } while (nav.MoveToFollowing(XPathNodeType.Element));
     }
-
+    /*
+    public static XmlDocument GetEmbeddedXml(Type type, string fileName) {
+      Stream str = GetEmbeddedFile(type, fileName);
+      XmlTextReader tr = new XmlTextReader(str);
+      XmlDocument xml = new XmlDocument();
+      xml.Load(tr);
+      return xml;
+    }
+    */
+
+    /// <summary>
+    /// Extracts an embedded file out of a given assembly.
+    /// </summary>
+    /// <param name="assemblyName">The namespace of you assembly.</param>
+    /// <param name="fileName">The name of the file to extract.</param>
+    /// <returns>A stream containing the file data.</returns>
+    public static Stream GetEmbeddedFile(string assemblyName, string fileName) {
+      try {
+        Assembly a = Assembly.Load(assemblyName);
+        Stream str = a.GetManifestResourceStream(assemblyName + "." + fileName);
+
+        if (str == null)
+          throw new Exception("Could not locate embedded resource '" + fileName + "' in assembly '" + assemblyName + "'");
+        return str;
+      }
+      catch (Exception e) {
+        throw new Exception(assemblyName + ": " + e.Message);
+      }
+    }
+
+   
     /// <summary>
     /// Policy
@@ -172,4 +206,5 @@
     private static void LoadFromXml(IList<Policy> policyList, string filename) {
       PermissionCollection permissionCollection = GetPermissions();
+      string assemblyName = Assembly.GetAssembly(typeof(HivePermissions)).GetName().Name;
       XPathDocument doc = new XPathDocument(filename);
       XPathNavigator nav = doc.CreateNavigator();
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj	(revision 2069)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj	(revision 2070)
@@ -162,5 +162,7 @@
   </ItemGroup>
   <ItemGroup>
-    <Content Include="Authorization\HivePermissionPolicy.xml" />
+    <EmbeddedResource Include="Authorization\HivePermissionPolicy.xml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2069)
+++ /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2070)
@@ -124,5 +124,5 @@
 copy "%SolutionDir%\HeuristicLab.Security.ADODataAccess\3.2\%Outdir%\HeuristicLab.Security.ADODataAccess-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.Security.Server\3.2\%Outdir%\HeuristicLab.Security.Server-3.2.dll" .\plugins
-
+copy "%SolutionDir%\HeuristicLab.Hive.Server.Core\3.2\%Outdir%\Authorization\*.xml" .\plugins
 echo "Platform: %Platform%, architecture: %PROCESSOR_ARCHITECTURE%"
 if "%Platform%" == "x86" (   